<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Basic Symtab Features</TITLE>
<link href="suif1_47.html" rel=Next>
<link href="suif1_45.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_45.html">previous</A>, <A HREF="suif1_47.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC46" HREF="suif1_toc.html#TOC46">Basic Features</A></H2>
<P>
<A NAME="IDX282"></A>

</P>
<P>
Symbol tables contain three different kinds of objects: types, symbols,
and variable definitions.  The entries within a symbol table may only be
referenced within the corresponding scope.  This includes references
within registered annotations.  Violating this condition may lead to
strange and unexpected errors.

</P>
<P>
<A NAME="IDX283"></A>
<A NAME="IDX284"></A>
<A NAME="IDX285"></A>
For simplicity, the symbol table entries are stored on lists instead of
using hash tables.  In theory, the actual implementation (lists or hash
tables) should not be visible in the symbol table interface.
Unfortunately that is not completely true for the current implementation
of SUIF--the lists can be accessed directly.  The <CODE>types</CODE>,
<CODE>symbols</CODE>, and <CODE>var_defs</CODE> methods return pointers to the
lists.  However, these lists should only be accessed to examine the
entries and should never be modified directly.  The symbol table classes
provide other methods to add and remove entries from the lists and those
methods should always be used.  If the list implementation becomes a
performance bottleneck, we may need to switch to hash tables, and code
that modifies the lists directly will be relatively hard to convert.

</P>
<P>
<A NAME="IDX286"></A>
<A NAME="IDX287"></A>
<A NAME="IDX288"></A>
To distinguish the symbol tables nested within a particular scope, each
table is given a name.  The <CODE>name</CODE> and <CODE>set_name</CODE> methods
retrieve and modify this name.  If a scope in the source program has a
name associated with it, that name may be used for the corresponding
symbol table.  For example, the name of a procedure-level symbol table
should generally be the same as the name of the procedure.  On the other
hand, nested scopes within procedures are typically unnamed, and names
must be generated for the corresponding symbol tables.

</P>
<P>
<A NAME="IDX289"></A>
<A NAME="IDX290"></A>
The symbol table names are used when printing a reference to a symbol or
named type.  Because the symbol or type name alone may not be sufficient
to identify it uniquely, the <CODE>chain_name</CODE> method is used to
identify the symbol table.  The chain name of a symbol table includes
the names of all of the symbol tables from the procedure-level downward,
separated by slashes (as in a Unix path).  The file-level name is not
included since it should always be clear from the context.  The chain
name for a global or file symbol table is the empty string.

</P>
<P>
<A NAME="IDX291"></A>
Duplicate names within a symbol table should be avoided whenever
possible.  Each kind of symbol has a separate name space.  A variable,
for example, may have the same name as a label in the same symbol table.
Named types and child symbol table names are also in separate name
spaces.  Duplicate names may be temporarily introduced but to avoid
problems they should be renamed as soon as possible.  The
<CODE>rename_duplicates</CODE> method is provided to check for and rename any
duplicates in a symbol table.  This method is automatically called
before writing out each symbol table.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_45.html">previous</A>, <A HREF="suif1_47.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
